> ## Documentation Index
> Fetch the complete documentation index at: https://docs.voiceflow.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update document metadata

> Update the metadata associated with the specified document.

<Info>The `documentMetadata` field can be used in agent KB metadata filter conditions. The `metadata` field is chunk-level and cannot be used for agent-level filtering. [Learn more about metadata filtering](/documentation/build/querying-the-knowledge-base#meta-data-filtering).</Info>



## OpenAPI

````yaml /specs/realtime/openapi.public.json patch /v1alpha1/public/knowledge-base/document/{documentID}
openapi: 3.0.0
info:
  title: Realtime
  description: Realtime gateway API service
  version: 1.0.0
  contact: {}
servers:
  - url: https://realtime-api.voiceflow.com
security: []
paths:
  /v1alpha1/public/knowledge-base/document/{documentID}:
    patch:
      tags:
        - KBPublicApiDocument
        - Public-Docs
      summary: Update document metadata
      description: >-
        Update the metadata associated with the specified document.


        <Info>The `documentMetadata` field can be used in agent KB metadata
        filter conditions. The `metadata` field is chunk-level and cannot be
        used for agent-level filtering. [Learn more about metadata
        filtering](/documentation/build/querying-the-knowledge-base#meta-data-filtering).</Info>
      operationId: KnowledgeBaseDocumentApiPublicHTTPController_patchOne
      parameters:
        - name: documentID
          required: true
          in: path
          description: ID of the document to target.
          schema:
            description: ID of the document to target.
            type: string
      requestBody:
        required: true
        content:
          knowledgeBase:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    documentMetadata:
                      description: >-
                        An array of document metadata fields.


                        > **💡 Tip:** This metadata can be used in agent KB
                        metadata filter conditions. [Learn more about metadata
                        filtering](/documentation/build/querying-the-knowledge-base#meta-data-filtering).
                      type: array
                      items:
                        type: object
                        properties:
                          key:
                            type: string
                            maxLength: 255
                          values:
                            type: array
                            items:
                              type: string
                        required:
                          - key
                          - values
                    metadata:
                      description: >-
                        Chunk-level metadata that can be used in a KB API query
                        request.


                        > **⚠️ Warning:** This metadata can't be used in agent
                        KB metadata filter conditions. Use `documentMetadata`
                        instead if you need agent-level metadata filtering.
                      type: object
                      additionalProperties: {}
                    projectEnvironmentIDOrAlias:
                      description: >-
                        The alias of the environment to target (ie. `main`). You
                        can find this in the environments page of your agent.


                        > **💡 Tip:** [Learn more about
                        Environments](/documentation/deploy/environments).
                      type: string
              required:
                - data
      responses:
        '200':
          description: The target document was updated successfully.
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: object
                    properties:
                      documentID:
                        type: string
                      data:
                        oneOf:
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - url
                              name:
                                type: string
                              url:
                                type: string
                              refreshRate:
                                type: string
                                enum:
                                  - daily
                                  - weekly
                                  - monthly
                                  - never
                                x-enumNames:
                                  - DAILY
                                  - WEEKLY
                                  - MONTHLY
                                  - NEVER
                              lastSuccessUpdate:
                                type: string
                              accessTokenID:
                                type: number
                              integrationExternalID:
                                type: string
                              source:
                                type: string
                                enum:
                                  - zendesk
                                  - shopify
                                x-enumNames:
                                  - ZENDESK
                                  - SHOPIFY
                            required:
                              - type
                              - name
                              - url
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - docx
                              name:
                                type: string
                              url:
                                type: string
                                nullable: true
                            required:
                              - type
                              - name
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - pdf
                              name:
                                type: string
                              url:
                                type: string
                                nullable: true
                            required:
                              - type
                              - name
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - text
                              name:
                                type: string
                              canEdit:
                                type: boolean
                              url:
                                type: string
                                nullable: true
                            required:
                              - type
                              - name
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - csv
                              name:
                                type: string
                              rowsCount:
                                type: number
                              url:
                                type: string
                                nullable: true
                            required:
                              - type
                              - name
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - xlsx
                              name:
                                type: string
                              rowsCount:
                                type: number
                              url:
                                type: string
                                nullable: true
                            required:
                              - type
                              - name
                          - type: object
                            properties:
                              type:
                                type: string
                                enum:
                                  - table
                              name:
                                type: string
                              rowsCount:
                                type: number
                              url:
                                type: string
                                nullable: true
                            required:
                              - type
                              - name
                              - rowsCount
                        nullable: true
                      updatedAt:
                        type: string
                        format: date-time
                      status:
                        type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - ERROR
                              - PENDING
                              - SUCCESS
                              - INITIALIZED
                            x-enumNames:
                              - ERROR
                              - PENDING
                              - SUCCESS
                              - INITIALIZED
                          data: {}
                        required:
                          - type
                    required:
                      - documentID
                      - data
                      - updatedAt
                      - status
                required:
                  - data
      security:
        - auth: []
components:
  securitySchemes:
    auth:
      type: apiKey
      in: header
      name: authorization
      description: Voiceflow API key

````